// --------------------------------------------------
// GOAL TESTER FOR HATP (MODULE)
// --------------------------------------------------

#include <stdlib.h>
#include <iostream>
#include<sstream>
#include<string>

#include "msgClient.hh"

using namespace std;

static int reqNumber = 1;

string createNewGoal(string task, string params) {
	ostringstream result;
	result << "(HATP-REQ ";
	result << "(REQ-TYPE plan) ";
	result << "(REQ-ID " << reqNumber << ") ";
	result << "(TASK-NAME " << task << ") ";
	result << "(PARAMETERS (. " << params << " .))";
	result << ")";
	reqNumber++;
	return result.str();
}

string createNewGoal2(string task, string params) {
	ostringstream result;
	result << "{\"HATP-REQ\": {";
	result << "\"REQ-TYPE\": \"plan\", ";
	result << "\"REQ-ID\": " << reqNumber << ", ";
	result << "\"TASK-NAME\": \"" << task << "\", ";
	result << "\"PARAMETERS\": [" << params << "]";
	result << "}}";
	reqNumber++;
	return result.str();
}

int main(int argc, char *argv[]){

	if(argc != 3) {
		cerr << "usage: GoalTester MP_SERVER MP_PORT" << endl;
		exit(1);
	}

	string HATP_ID	 = "HATP";
	string MP_SERVER = argv[1];
	string MP_PORT	 = argv[2];

	msgClient* mp = new msgClient();
	mp->connect("GOALTESTER", MP_SERVER, atoi(MP_PORT.c_str()));

	bool nextGoal = true;
	cout << "Welcome in HATPGoalTester" << endl;
	cout << "Syntax is (for example): Take \"GREY_TAPE\", \"HRP2TABLE\" " << endl;
	cout << "..." << endl;
	mp->sendMessage(HATP_ID, "{\"HATP-REQ\": {\"REQ-TYPE\": \"setMaxTime\", \"MAXTIME\": 3600}}");
	while(nextGoal) {
		string task, pars;
	    cout << "Enter the name of an existing task (ex: Take) : ";
		getline(std::cin, task);
	    cout << "parameters (ex: \"arg1\", \"arg2\") : ";
		getline(std::cin, pars);
		if(task != "") {
			mp->sendMessage(HATP_ID, createNewGoal2(task, pars));
			cout << "new goal sent to HATP: " << task <<"("<<pars<<")" << endl;
		}
		else nextGoal = false;
	}

}
